/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package servlets;

import hibernate.Userstatistic;
import hibernate.util.HibernateUtil;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.hibernate.Query;
import org.hibernate.Session;

/**
 *
 * @author Ani
 */
public class ListUsers extends HttpServlet {
   
    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response) throws IOException{
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        List<Userstatistic> mostGameWinned;
        List<Userstatistic> mostGameLost;
        List<Userstatistic> mostGamePlayed;
        List<Userstatistic> mostGameRestarted;
        request.getSession().setAttribute("listed", true);

        try {
            Session session = HibernateUtil.getSessionFactory().openSession();
            session.beginTransaction();
            
            Query query = session.createQuery("FROM Userstatistic us " +
                    "ORDER BY us.winned DESC");
            query.setMaxResults(10);
            mostGameWinned = query.list();
            request.getSession().setAttribute("mostGameWinned", mostGameWinned);

            query = session.createQuery("FROM Userstatistic us " +
                    "ORDER BY us.lost DESC");
            query.setMaxResults(10);
            mostGameLost = query.list();
            request.getSession().setAttribute("mostGameLost", mostGameLost);

            query = session.createQuery("FROM Userstatistic us " +
                    "ORDER BY us.allGame DESC");
            query.setMaxResults(10);
            mostGamePlayed = query.list();
            request.getSession().setAttribute("mostGamePlayed", mostGamePlayed);

            query = session.createQuery("FROM Userstatistic us " +
                    "ORDER BY us.gamerestarted DESC");
            query.setMaxResults(10);
            mostGameRestarted = query.list();
            request.getSession().setAttribute("mostGameRestarted", mostGameRestarted);

            session.getTransaction().commit();
            session.close();
            response.sendRedirect("statistic.jsp");
        } catch(Exception ex) {
            
        } finally { 
            out.close();
        }
    } 

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
